package org.gcube.portlets.user.geoportaldataviewer.client;

import com.google.gwt.core.client.GWT;
import com.google.gwt.user.client.Window;

import java.util.Collections;
import java.util.List;
import java.util.Map;
import java.util.Set;


class StartParameters {
    public StartParameters(Map<String, List<String>> parameters) {
        if (parameters == null || parameters.isEmpty())
            GWT.log("!!!! NB : NO QUERY PARAMETERS");
        else {
            paramWmsRequest = getFirst(parameters, GeoportalDataViewerConstants.GET_WMS_PARAMETER);
            paramLayerTitle = Window.Location.getParameter(GeoportalDataViewerConstants.GET_LAYER_TITLE);

            paramGeonaItemType = Window.Location.getParameter(GeoportalDataViewerConstants.GET_GEONA_ITEM_TYPE);
            paramGeonaItemID = Window.Location.getParameter(GeoportalDataViewerConstants.GET_GEONA_ITEM_ID);
        }
    }

    // retro usage?
    /** WMS Link -> Layer Name [optional]*/
    public Map<String,String> toOpenLayers() {
        return Collections.emptyMap();
    }

    public Set<String> toOpenCollections(){
        return Collections.emptySet();
    }

    public Set<String> toOpenProjects(){
        return Collections.emptySet();
    }


    private String getFirst(Map<String, List<String>> parameters, String key) {
        List<String> values = parameters.get(key);
        if (values != null && !values.isEmpty()) {
            GWT.log("Param " + key + "Getting First value of : " + values);
            return values.get(0);
        } else return null;
    }

    /**
     * The param wms request.
     */
    private String paramWmsRequest;

    /**
     * The param UUID.
     */
    // private String paramUUID;

    private String paramGeonaItemType;
    /**
     * The param layer title.
     */
    private String paramLayerTitle;

    private String paramGeonaItemID;

	public String getParamWmsRequest() {
		return paramWmsRequest;
	}

	public String getParamGeonaItemType() {
		return paramGeonaItemType;
	}

	public String getParamLayerTitle() {
		return paramLayerTitle;
	}

	public String getParamGeonaItemID() {
		return paramGeonaItemID;
	}

    
    
}
